//*****************************************************************
// 
//  JAVA Source for com.idautomation.databar; 2010
//  
//	 Copyright IDAutomation.com, Inc. All rights reserved.
//	Redistribution and use of this code in source and/or binary 
//	forms, with or without modification, are permitted provided 
//	that: (1) all copies of the source code retain the above 
//	unmodified copyright notice and this entire unmodified 
//	section of text, (2) You or Your organization owns a valid 
//	Developer License to this product from IDAutomation.com 
//	and, (3) when any portion of this code is bundled in any 
//	form with an application, a valid notice must be provided 
//	within the user documentation, start-up screen or in the 
//	help-about section of the application that specifies 
//	IDAutomation.com as the provider of the Software bundled 
//	with the application.
//*****************************************************************

package com.idautomation.databar;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.awt.Graphics2D.*;
import java.awt.*;

public class IDAutomationSecureServlet extends HttpServlet
    {

        /**
         * Handle the HTTP POST method by sending an e-mail
         *
         *
         */
         private boolean debug=false;

	    public void init() throws ServletException  {

	    }


       // MODIFY THIS METHOD TO RETRIEVE DATA TO ENCODE, CREATE THE BARCODE AND SET THE PARAMETERS
       private DataBar getChart (HttpServletRequest request) {
     	  DataBar cb=new DataBar();

           cb.code="SecureServlet";

           return cb;
       }

       // Handle the request
       // 1. create barcode
       // 2. draw barcode in a Buffered Image
       // 3. encode image as GIF or JPEG and send it to the browser
        public void doGet (HttpServletRequest request,
                	   HttpServletResponse response)
        throws ServletException, IOException
        {
               PrintWriter		out;
               ServletOutputStream outb;
		   //default encoding type
               String encode="gif";
               if (request!=null) {
                 if (request.getParameter("I")!=null)  encode=request.getParameter("I").toLowerCase();
                 if (encode.compareTo("gif")!=0) encode="jpeg";
               }

			response.setContentType("image/"+encode);
			outb=response.getOutputStream();
            // avoid caching in browser
		response.setHeader ("Pragma", "no-cache");
		response.setHeader ("Cache-Control", "no-cache");
		response.setDateHeader ("Expires",0);



	try { 
		// find sizes
		int w=10;
		int h=10;
		// get the BarCode
		DataBar cb=getChart(request);
		if ((request!=null) && (request.getParameter("W")!=null) && (request.getParameter("H")!=null)) {
				w=new Integer(request.getParameter("W")).intValue();
				h=new Integer(request.getParameter("H")).intValue();
		}
			else {
				//a temp image must be created to find the preferred size
//				cb.autoSize=true;
				cb.setSize(170,90);
		            java.awt.image.BufferedImage imageTemp = new java.awt.image.BufferedImage( cb.getSize().width,cb.getSize().height,java.awt.image.BufferedImage.TYPE_BYTE_INDEXED );
				java.awt.Graphics imgTempGraphics = imageTemp.createGraphics();
				cb.paint(imgTempGraphics);
				cb.invalidate();
				w=cb.getSize().width;
				h=cb.getSize().height;
				imgTempGraphics.dispose();
		}

		java.awt.image.BufferedImage BarImage=new java.awt.image.BufferedImage(w,h,java.awt.image.BufferedImage.TYPE_INT_RGB);
		java.awt.Graphics2D BarGraphics=BarImage.createGraphics();

                if (debug) System.out.println("Size: "+w+" "+h);
                cb.setSize(w,h);
                cb.paint(BarGraphics);

               if (encode.compareToIgnoreCase("gif")==0) {
					// encode buffered image to a gif
					cb.setSize(w,h);
					com.idautomation.databar.encoder.GifEncoder encoder = new com.idautomation.databar.encoder.GifEncoder(BarImage  ,outb);
					encoder.encode();
                }
                else
                {
					// create JPEG image
					com.sun.image.codec.jpeg.JPEGImageEncoder encoder = com.sun.image.codec.jpeg.JPEGCodec.createJPEGEncoder(outb );
					//increase the JPEG quality to 100%
      				com.sun.image.codec.jpeg.JPEGEncodeParam param = encoder.getDefaultJPEGEncodeParam( BarImage); 
					param.setQuality(1.0F,true);
            		encoder.setJPEGEncodeParam(param);
					encoder.encode( BarImage,param  );
                }


		} catch (Exception e) { e.printStackTrace();}


		}


        public void doPost (HttpServletRequest request,
                	   HttpServletResponse response)
        throws ServletException
        {
        try {
              doGet(request,response);
          } catch (Exception e) { e.printStackTrace();}
	}

    }
